#ifndef _H_C37D9BAE9F272472CC195306D3A73ED5_MetricData__H_
#define _H_C37D9BAE9F272472CC195306D3A73ED5_MetricData__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "ros_monitoring_msgs/msg/dds_opensplice/MetricDimension_.h"


namespace ros_monitoring_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace MetricData_Constants
            {
                const ::DDS::String_mgr UNIT_SEC_ = "sec";

                const ::DDS::String_mgr UNIT_MILLI_SEC_ = "msec";

                const ::DDS::String_mgr UNIT_MICRO_SEC_ = "usec";

                const ::DDS::String_mgr UNIT_PERCENTAGE_ = "percent";

                const ::DDS::String_mgr UNIT_COUNT_ = "count";

                const ::DDS::String_mgr UNIT_COUNT_PER_SEC_ = "count_per_sec";

                const ::DDS::String_mgr UNIT_BYTES_ = "bytes";

                const ::DDS::String_mgr UNIT_KILOBYTES_ = "kilobytes";

                const ::DDS::String_mgr UNIT_MEGABYTES_ = "megabytes";

                const ::DDS::String_mgr UNIT_GIGABYTES_ = "gigabytes";

                const ::DDS::String_mgr UNIT_TERABYTES_ = "terabytes";

                const ::DDS::String_mgr UNIT_BYTES_PER_SEC_ = "bytes_per_sec";

                const ::DDS::String_mgr UNIT_KILOBYTES_PER_SEC_ = "kilobytes_per_sec";

                const ::DDS::String_mgr UNIT_MEGABYTES_PER_SEC_ = "megabytes_per_sec";

                const ::DDS::String_mgr UNIT_GIGABYTES_PER_SEC_ = "gigabytes_per_sec";

                const ::DDS::String_mgr UNIT_TERABYTES_PER_SEC_ = "terabytes_per_sec";

                const ::DDS::String_mgr UNIT_NONE_ = "none";

                const ::DDS::String_mgr NA_STRING_ = "non_applicable_string_value";

            }

            struct  MetricData_
            {
                struct _dimensions__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::ros_monitoring_msgs::msg::dds_::MetricDimension_, struct _dimensions__seq_uniq_ > _dimensions__seq;
                typedef DDS_DCPSSequence_var< _dimensions__seq > _dimensions__seq_var;
                typedef DDS_DCPSSequence_out< _dimensions__seq > _dimensions__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::String_mgr metric_name_;
                ::DDS::String_mgr unit_;
                ::DDS::Double value_;
                ::builtin_interfaces::msg::dds_::Time_ time_stamp_;
                _dimensions__seq dimensions_;
            };

            typedef DDS_DCPSStruct_var<MetricData_> MetricData__var;
            typedef DDS_DCPSStruct_out < MetricData_> MetricData__out;

        }

    }

}

#endif /* _H_C37D9BAE9F272472CC195306D3A73ED5_MetricData__H_ */
