// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ros_monitoring_msgs:msg/MetricData.idl
// generated code does not contain a copyright notice
#include "ros_monitoring_msgs/msg/metric_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `metric_name`
// Member `unit`
#include "rosidl_generator_c/string_functions.h"
// Member `time_stamp`
#include "builtin_interfaces/msg/time__functions.h"
// Member `dimensions`
#include "ros_monitoring_msgs/msg/metric_dimension__functions.h"

bool
ros_monitoring_msgs__msg__MetricData__init(ros_monitoring_msgs__msg__MetricData * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ros_monitoring_msgs__msg__MetricData__destroy(msg);
    return false;
  }
  // metric_name
  if (!rosidl_generator_c__String__init(&msg->metric_name)) {
    ros_monitoring_msgs__msg__MetricData__destroy(msg);
    return false;
  }
  // unit
  if (!rosidl_generator_c__String__init(&msg->unit)) {
    ros_monitoring_msgs__msg__MetricData__destroy(msg);
    return false;
  }
  // value
  // time_stamp
  if (!builtin_interfaces__msg__Time__init(&msg->time_stamp)) {
    ros_monitoring_msgs__msg__MetricData__destroy(msg);
    return false;
  }
  // dimensions
  if (!ros_monitoring_msgs__msg__MetricDimension__Sequence__init(&msg->dimensions, 0)) {
    ros_monitoring_msgs__msg__MetricData__destroy(msg);
    return false;
  }
  return true;
}

void
ros_monitoring_msgs__msg__MetricData__fini(ros_monitoring_msgs__msg__MetricData * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // metric_name
  rosidl_generator_c__String__fini(&msg->metric_name);
  // unit
  rosidl_generator_c__String__fini(&msg->unit);
  // value
  // time_stamp
  builtin_interfaces__msg__Time__fini(&msg->time_stamp);
  // dimensions
  ros_monitoring_msgs__msg__MetricDimension__Sequence__fini(&msg->dimensions);
}

ros_monitoring_msgs__msg__MetricData *
ros_monitoring_msgs__msg__MetricData__create()
{
  ros_monitoring_msgs__msg__MetricData * msg = (ros_monitoring_msgs__msg__MetricData *)malloc(sizeof(ros_monitoring_msgs__msg__MetricData));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ros_monitoring_msgs__msg__MetricData));
  bool success = ros_monitoring_msgs__msg__MetricData__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ros_monitoring_msgs__msg__MetricData__destroy(ros_monitoring_msgs__msg__MetricData * msg)
{
  if (msg) {
    ros_monitoring_msgs__msg__MetricData__fini(msg);
  }
  free(msg);
}


bool
ros_monitoring_msgs__msg__MetricData__Sequence__init(ros_monitoring_msgs__msg__MetricData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ros_monitoring_msgs__msg__MetricData * data = NULL;
  if (size) {
    data = (ros_monitoring_msgs__msg__MetricData *)calloc(size, sizeof(ros_monitoring_msgs__msg__MetricData));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ros_monitoring_msgs__msg__MetricData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ros_monitoring_msgs__msg__MetricData__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ros_monitoring_msgs__msg__MetricData__Sequence__fini(ros_monitoring_msgs__msg__MetricData__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ros_monitoring_msgs__msg__MetricData__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ros_monitoring_msgs__msg__MetricData__Sequence *
ros_monitoring_msgs__msg__MetricData__Sequence__create(size_t size)
{
  ros_monitoring_msgs__msg__MetricData__Sequence * array = (ros_monitoring_msgs__msg__MetricData__Sequence *)malloc(sizeof(ros_monitoring_msgs__msg__MetricData__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ros_monitoring_msgs__msg__MetricData__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ros_monitoring_msgs__msg__MetricData__Sequence__destroy(ros_monitoring_msgs__msg__MetricData__Sequence * array)
{
  if (array) {
    ros_monitoring_msgs__msg__MetricData__Sequence__fini(array);
  }
  free(array);
}
