// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ros_monitoring_msgs:msg/MetricList.idl
// generated code does not contain a copyright notice

#ifndef ROS_MONITORING_MSGS__MSG__METRIC_LIST__STRUCT_HPP_
#define ROS_MONITORING_MSGS__MSG__METRIC_LIST__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'metrics'
#include "ros_monitoring_msgs/msg/metric_data__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ros_monitoring_msgs__msg__MetricList __attribute__((deprecated))
#else
# define DEPRECATED__ros_monitoring_msgs__msg__MetricList __declspec(deprecated)
#endif

namespace ros_monitoring_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MetricList_
{
  using Type = MetricList_<ContainerAllocator>;

  explicit MetricList_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit MetricList_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _metrics_type =
    std::vector<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>, typename ContainerAllocator::template rebind<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>>::other>;
  _metrics_type metrics;

  // setters for named parameter idiom
  Type & set__metrics(
    const std::vector<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>, typename ContainerAllocator::template rebind<ros_monitoring_msgs::msg::MetricData_<ContainerAllocator>>::other> & _arg)
  {
    this->metrics = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ros_monitoring_msgs::msg::MetricList_<ContainerAllocator> *;
  using ConstRawPtr =
    const ros_monitoring_msgs::msg::MetricList_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ros_monitoring_msgs::msg::MetricList_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ros_monitoring_msgs::msg::MetricList_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ros_monitoring_msgs::msg::MetricList_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ros_monitoring_msgs::msg::MetricList_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ros_monitoring_msgs::msg::MetricList_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ros_monitoring_msgs::msg::MetricList_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ros_monitoring_msgs::msg::MetricList_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ros_monitoring_msgs::msg::MetricList_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ros_monitoring_msgs__msg__MetricList
    std::shared_ptr<ros_monitoring_msgs::msg::MetricList_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ros_monitoring_msgs__msg__MetricList
    std::shared_ptr<ros_monitoring_msgs::msg::MetricList_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MetricList_ & other) const
  {
    if (this->metrics != other.metrics) {
      return false;
    }
    return true;
  }
  bool operator!=(const MetricList_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MetricList_

// alias to use template instance with default allocator
using MetricList =
  ros_monitoring_msgs::msg::MetricList_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ros_monitoring_msgs

#endif  // ROS_MONITORING_MSGS__MSG__METRIC_LIST__STRUCT_HPP_
