// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ros_monitoring_msgs:msg/MetricDimension.idl
// generated code does not contain a copyright notice

#ifndef ROS_MONITORING_MSGS__MSG__METRIC_DIMENSION__STRUCT_HPP_
#define ROS_MONITORING_MSGS__MSG__METRIC_DIMENSION__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__ros_monitoring_msgs__msg__MetricDimension __attribute__((deprecated))
#else
# define DEPRECATED__ros_monitoring_msgs__msg__MetricDimension __declspec(deprecated)
#endif

namespace ros_monitoring_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MetricDimension_
{
  using Type = MetricDimension_<ContainerAllocator>;

  explicit MetricDimension_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->value = "";
    }
  }

  explicit MetricDimension_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : name(_alloc),
    value(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->value = "";
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _name_type name;
  using _value_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _value_type value;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__value(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator> *;
  using ConstRawPtr =
    const ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ros_monitoring_msgs__msg__MetricDimension
    std::shared_ptr<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ros_monitoring_msgs__msg__MetricDimension
    std::shared_ptr<ros_monitoring_msgs::msg::MetricDimension_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MetricDimension_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const MetricDimension_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MetricDimension_

// alias to use template instance with default allocator
using MetricDimension =
  ros_monitoring_msgs::msg::MetricDimension_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ros_monitoring_msgs

#endif  // ROS_MONITORING_MSGS__MSG__METRIC_DIMENSION__STRUCT_HPP_
